#ifndef __X10_UTIL_HASHMAP__ENTRIESITERATOR_H
#define __X10_UTIL_HASHMAP__ENTRIESITERATOR_H

#include <x10rt.h>


#define X10_LANG_OBJECT_H_NODEPS
#include <x10/lang/Object.h>
#undef X10_LANG_OBJECT_H_NODEPS
#define X10_LANG_ITERATOR_H_NODEPS
#include <x10/lang/Iterator.h>
#undef X10_LANG_ITERATOR_H_NODEPS
namespace x10 { namespace util { 
template<class TPMGL(Key), class TPMGL(Value)> class HashMap__HashEntry;
} } 
#define X10_LANG_INT_H_NODEPS
#include <x10/lang/Int.h>
#undef X10_LANG_INT_H_NODEPS
namespace x10 { namespace util { 
template<class TPMGL(K), class TPMGL(V)> class HashMap;
} } 
namespace x10 { namespace lang { 
class Int;
} } 
namespace x10 { namespace util { 
template<class TPMGL(T)> class IndexedMemoryChunk;
} } 
namespace x10 { namespace lang { 
class Boolean;
} } 
namespace x10 { namespace lang { 
class RuntimeException;
} } 
namespace x10 { namespace lang { 
class String;
} } 
namespace x10 { namespace util { 

template<class TPMGL(Key), class TPMGL(Value)> class HashMap__EntriesIterator;
template <> class HashMap__EntriesIterator<void, void>;
template<class TPMGL(Key), class TPMGL(Value)> class HashMap__EntriesIterator : public x10::lang::Object
  {
    public:
    RTT_H_DECLS_CLASS
    
    static x10aux::itable_entry _itables[3];
    
    virtual x10aux::itable_entry* _getITables() { return _itables; }
    
    static typename x10::lang::Iterator<x10aux::ref<x10::util::HashMap__HashEntry<TPMGL(Key), TPMGL(Value)> > >::template itable<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> > _itable_0;
    
    static x10::lang::Any::itable<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> > _itable_1;
    
    x10aux::ref<x10::util::HashMap<TPMGL(Key), TPMGL(Value)> > FMGL(map);
    
    x10_int FMGL(i);
    
    x10_int FMGL(originalModCount);
    
    void _constructor(x10aux::ref<x10::util::HashMap<TPMGL(Key), TPMGL(Value)> > map);
    
    static x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> > _make(
             x10aux::ref<x10::util::HashMap<TPMGL(Key), TPMGL(Value)> > map);
    
    virtual void advance();
    virtual x10_boolean hasNext();
    virtual x10aux::ref<x10::util::HashMap__HashEntry<TPMGL(Key), TPMGL(Value)> >
      next();
    virtual x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> >
      x10__util__HashMap__EntriesIterator____x10__util__HashMap__EntriesIterator__this(
      );
    void __fieldInitializers47044();
    
    // Serialization
    public: static const x10aux::serialization_id_t _serialization_id;
    
    public: virtual x10aux::serialization_id_t _get_serialization_id() {
         return _serialization_id;
    }
    
    public: virtual void _serialize_body(x10aux::serialization_buffer& buf);
    
    public: static x10aux::ref<x10::lang::Reference> _deserializer(x10aux::deserialization_buffer& buf);
    
    public: void _deserialize_body(x10aux::deserialization_buffer& buf);
    
};
template <> class HashMap__EntriesIterator<void, void> : public x10::lang::Object
{
    public:
    static x10aux::RuntimeType rtt;
    static const x10aux::RuntimeType* getRTT() { return & rtt; }
    
};

} } 
#endif // X10_UTIL_HASHMAP__ENTRIESITERATOR_H

namespace x10 { namespace util { 
template<class TPMGL(Key), class TPMGL(Value)> class HashMap__EntriesIterator;
} } 

#ifndef X10_UTIL_HASHMAP__ENTRIESITERATOR_H_NODEPS
#define X10_UTIL_HASHMAP__ENTRIESITERATOR_H_NODEPS
#include <x10/lang/Object.h>
#include <x10/lang/Iterator.h>
#include <x10/util/HashMap__HashEntry.h>
#include <x10/util/HashMap.h>
#include <x10/lang/Int.h>
#include <x10/util/IndexedMemoryChunk.h>
#include <x10/lang/Boolean.h>
#include <x10/lang/RuntimeException.h>
#include <x10/lang/String.h>
#ifndef X10_UTIL_HASHMAP__ENTRIESITERATOR_H_GENERICS
#define X10_UTIL_HASHMAP__ENTRIESITERATOR_H_GENERICS
#endif // X10_UTIL_HASHMAP__ENTRIESITERATOR_H_GENERICS
#ifndef X10_UTIL_HASHMAP__ENTRIESITERATOR_H_IMPLEMENTATION
#define X10_UTIL_HASHMAP__ENTRIESITERATOR_H_IMPLEMENTATION
#include <x10/util/HashMap__EntriesIterator.h>

template<class TPMGL(Key), class TPMGL(Value)> typename x10::lang::Iterator<x10aux::ref<x10::util::HashMap__HashEntry<TPMGL(Key), TPMGL(Value)> > >::template itable<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> >  x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>::_itable_0(&x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>::equals, &x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>::hasNext, &x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>::hashCode, &x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>::next, &x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>::toString, &x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>::typeName);
template<class TPMGL(Key), class TPMGL(Value)> x10::lang::Any::itable<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> >  x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>::_itable_1(&x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>::equals, &x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>::hashCode, &x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>::toString, &x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>::typeName);
template<class TPMGL(Key), class TPMGL(Value)> x10aux::itable_entry x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>::_itables[3] = {x10aux::itable_entry(&x10aux::getRTT<x10::lang::Iterator<x10aux::ref<x10::util::HashMap__HashEntry<TPMGL(Key), TPMGL(Value)> > > >, &_itable_0), x10aux::itable_entry(&x10aux::getRTT<x10::lang::Any>, &_itable_1), x10aux::itable_entry(NULL, (void*)x10aux::getRTT<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> >())};

//#line 230 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": x10.ast.X10FieldDecl_c

//#line 231 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": x10.ast.X10FieldDecl_c

//#line 232 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": x10.ast.X10FieldDecl_c

//#line 234 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": x10.ast.X10ConstructorDecl_c
template<class TPMGL(Key), class TPMGL(Value)> void x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>::_constructor(
                                                 x10aux::ref<x10::util::HashMap<TPMGL(Key), TPMGL(Value)> > map) {
    
    //#line 234 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": x10.ast.X10ConstructorCall_c
    (this)->::x10::lang::Object::_constructor();
    
    //#line 234 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": x10.ast.AssignPropertyCall_c
    
    //#line 229 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": Eval of x10.ast.X10Call_c
    ((x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> >)this)->x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>::__fieldInitializers47044();
    
    //#line 234 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": Eval of x10.ast.X10FieldAssign_c
    ((x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> >)this)->
      FMGL(map) = map;
    
    //#line 234 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": Eval of x10.ast.X10FieldAssign_c
    ((x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> >)this)->
      FMGL(i) = ((x10_int)0);
    
    //#line 234 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": Eval of x10.ast.X10FieldAssign_c
    ((x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> >)this)->
      FMGL(originalModCount) = x10aux::nullCheck(map)->FMGL(modCount);
}
template<class TPMGL(Key), class TPMGL(Value)> x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> > x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>::_make(
                                                 x10aux::ref<x10::util::HashMap<TPMGL(Key), TPMGL(Value)> > map)
{
    x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> > this_ = new (memset(x10aux::alloc<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> >(), 0, sizeof(x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>))) x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>();
    this_->_constructor(map);
    return this_;
}



//#line 236 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": x10.ast.X10MethodDecl_c
template<class TPMGL(Key), class TPMGL(Value)> void x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>::advance(
  ) {
    
    //#line 237 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": x10.ast.X10While_c
    while (((((x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> >)this)->
               FMGL(i)) < ((x10aux::nullCheck(((x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> >)this)->
                                                FMGL(map))->
                              FMGL(table))->length()))) {
        
        //#line 238 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": x10.ast.X10If_c
        if ((!x10aux::struct_equals((x10aux::nullCheck(((x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> >)this)->
                                                         FMGL(map))->
                                       FMGL(table))->__apply(((x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> >)this)->
                                                               FMGL(i)),
                                    X10_NULL)) && !(x10aux::nullCheck((x10aux::nullCheck(((x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> >)this)->
                                                                                           FMGL(map))->
                                                                         FMGL(table))->__apply(((x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> >)this)->
                                                                                                 FMGL(i)))->
                                                      FMGL(removed)))
        {
            
            //#line 239 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": x10.ast.X10Return_c
            return;
        }
        
        //#line 240 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": x10.ast.X10LocalDecl_c
        x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> > x47363 =
          ((x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> >)this);
        
        //#line 240 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": polyglot.ast.Empty_c
        ;
        
        //#line 240 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": Eval of x10.ast.X10FieldAssign_c
        x10aux::nullCheck(x47363)->FMGL(i) = ((x10_int) ((x10aux::nullCheck(x47363)->
                                                            FMGL(i)) + (((x10_int)1))));
    }
    
}

//#line 244 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": x10.ast.X10MethodDecl_c
template<class TPMGL(Key), class TPMGL(Value)> x10_boolean
  x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>::hasNext(
  ) {
    
    //#line 245 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": x10.ast.X10If_c
    if (((((x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> >)this)->
            FMGL(i)) < ((x10aux::nullCheck(((x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> >)this)->
                                             FMGL(map))->
                           FMGL(table))->length()))) {
        
        //#line 247 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": x10.ast.X10Return_c
        return true;
        
    }
    
    //#line 249 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": x10.ast.X10Return_c
    return false;
    
}

//#line 252 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": x10.ast.X10MethodDecl_c
template<class TPMGL(Key), class TPMGL(Value)> x10aux::ref<x10::util::HashMap__HashEntry<TPMGL(Key), TPMGL(Value)> >
  x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>::next(
  ) {
    
    //#line 253 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": x10.ast.X10If_c
    if ((!x10aux::struct_equals(((x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> >)this)->
                                  FMGL(originalModCount),
                                x10aux::nullCheck(((x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> >)this)->
                                                    FMGL(map))->
                                  FMGL(modCount)))) {
        
        //#line 253 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": polyglot.ast.Throw_c
        x10aux::throwException(x10aux::nullCheck(x10::lang::RuntimeException::_make(((((x10aux::string_utils::lit("Your code has a concurrency bug! You updated the hashmap ")) + (((x10_int) ((x10aux::nullCheck(((x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> >)this)->
                                                                                                                                                                                                                    FMGL(map))->
                                                                                                                                                                                                  FMGL(modCount)) - (((x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> >)this)->
                                                                                                                                                                                                                       FMGL(originalModCount))))))) + (x10aux::string_utils::lit(" times since you created the iterator."))))));
    }
    
    //#line 254 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": x10.ast.X10LocalDecl_c
    x10_int j = ((x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> >)this)->
                  FMGL(i);
    
    //#line 256 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": x10.ast.X10LocalDecl_c
    x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> > x47364 =
      ((x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> >)this);
    
    //#line 256 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": polyglot.ast.Empty_c
    ;
    
    //#line 256 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": Eval of x10.ast.X10FieldAssign_c
    x10aux::nullCheck(x47364)->FMGL(i) = ((x10_int) ((x10aux::nullCheck(x47364)->
                                                        FMGL(i)) + (((x10_int)1))));
    
    //#line 257 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": Eval of x10.ast.X10Call_c
    ((x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> >)this)->advance();
    
    //#line 258 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": x10.ast.X10Return_c
    return (x10aux::nullCheck(((x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> >)this)->
                                FMGL(map))->FMGL(table))->__apply(j);
    
}

//#line 229 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": x10.ast.X10MethodDecl_c
template<class TPMGL(Key), class TPMGL(Value)> x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> >
  x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>::x10__util__HashMap__EntriesIterator____x10__util__HashMap__EntriesIterator__this(
  ) {
    
    //#line 229 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": x10.ast.X10Return_c
    return ((x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> >)this);
    
}

//#line 229 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": x10.ast.X10MethodDecl_c
template<class TPMGL(Key), class TPMGL(Value)> void x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>::__fieldInitializers47044(
  ) {
    
    //#line 229 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": Eval of x10.ast.X10FieldAssign_c
    ((x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> >)this)->
      FMGL(i) = ((x10_int)0);
    
    //#line 229 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/HashMap.x10": Eval of x10.ast.X10FieldAssign_c
    ((x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> >)this)->
      FMGL(originalModCount) = ((x10_int)0);
}
template<class TPMGL(Key), class TPMGL(Value)> const x10aux::serialization_id_t x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>::_serialization_id = 
    x10aux::DeserializationDispatcher::addDeserializer(x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>::_deserializer, x10aux::CLOSURE_KIND_NOT_ASYNC);

template<class TPMGL(Key), class TPMGL(Value)> void x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>::_serialize_body(x10aux::serialization_buffer& buf) {
    x10::lang::Object::_serialize_body(buf);
    buf.write(this->FMGL(map));
    buf.write(this->FMGL(i));
    buf.write(this->FMGL(originalModCount));
    
}

template<class TPMGL(Key), class TPMGL(Value)> x10aux::ref<x10::lang::Reference> x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>::_deserializer(x10aux::deserialization_buffer& buf) {
    x10aux::ref<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> > this_ = new (memset(x10aux::alloc<x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)> >(), 0, sizeof(x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>))) x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>();
    buf.record_reference(this_);
    this_->_deserialize_body(buf);
    return this_;
}

template<class TPMGL(Key), class TPMGL(Value)> void x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>::_deserialize_body(x10aux::deserialization_buffer& buf) {
    x10::lang::Object::_deserialize_body(buf);
    FMGL(map) = buf.read<x10aux::ref<x10::util::HashMap<TPMGL(Key), TPMGL(Value)> > >();
    FMGL(i) = buf.read<x10_int>();
    FMGL(originalModCount) = buf.read<x10_int>();
}

template<class TPMGL(Key), class TPMGL(Value)> x10aux::RuntimeType x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>::rtt;
template<class TPMGL(Key), class TPMGL(Value)> void x10::util::HashMap__EntriesIterator<TPMGL(Key), TPMGL(Value)>::_initRTT() {
    const x10aux::RuntimeType *canonical = x10aux::getRTT<x10::util::HashMap__EntriesIterator<void, void> >();
    if (rtt.initStageOne(canonical)) return;
    const x10aux::RuntimeType* parents[2] = { x10aux::getRTT<x10::lang::Object>(), x10aux::getRTT<x10::lang::Iterator<x10aux::ref<x10::util::HashMap__HashEntry<TPMGL(Key), TPMGL(Value)> > > >()};
    const x10aux::RuntimeType* params[2] = { x10aux::getRTT<TPMGL(Key)>(), x10aux::getRTT<TPMGL(Value)>()};
    x10aux::RuntimeType::Variance variances[2] = { x10aux::RuntimeType::invariant, x10aux::RuntimeType::invariant};
    const char *baseName = "x10.util.HashMap.EntriesIterator";
    rtt.initStageTwo(baseName, x10aux::RuntimeType::class_kind, 2, parents, 2, params, variances);
}
#endif // X10_UTIL_HASHMAP__ENTRIESITERATOR_H_IMPLEMENTATION
#endif // __X10_UTIL_HASHMAP__ENTRIESITERATOR_H_NODEPS
